using System;
using System.Threading;

namespace ConsoleApplication1
{

    
    public class Producer
    {
        private Buffer _buffer;
        private Random _random;
        private Boolean _isAsleep;
        private static Boolean _wakeProducersUp;


        public Producer(Buffer buffer)
        {
            _random = new Random();
            this._buffer = buffer;
        }
        
        
        public void Produce()
        {
            while (true)
            {
                if (_isAsleep)
                {
                    Console.WriteLine("producer asleep...");
                    Thread.Sleep(50);

                    if (_wakeProducersUp)
                    {
                        Console.WriteLine("producer was woken up");
                        _isAsleep = false;
                    }
                }
                else
                {
                    Thread.Sleep(_random.Next(500, 1500));
                    Mutex m = _buffer.getMutex();
                    m.WaitOne();

                    if (_buffer.empty())
                    {
                        Consumer.WakeUp();
                    }

                    if (!_buffer.full())
                    {
                        Car c = new Car();
                        _buffer.push(c);
                        Console.WriteLine("car " + c.getThisCarId() + " added");
                    }
                    else
                    {
                        _wakeProducersUp = false;
                        _isAsleep = true;
                        
                    }

                    m.ReleaseMutex();

                }
            }
        }

        public static void WakeUp()
        {
            _wakeProducersUp = true;
        }
    }
    
}
